#ifndef __mor_xmbctype_h__
#define __mor_xmbctype_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#define _XMBGETL(c) ((c) & 255)
#define _XMBGETH(c) (((c) >> 8) & 255)
#define _ISXMB16(c) ((c) & 0x8000)

_EXTERN (int_ isxmbclower (int_));
_EXTERN (int_ isxmbcupper (int_));
_EXTERN (int_ xmbctolower (int_));
_EXTERN (int_ xmbctoupper (int_));

#ifndef __NO_CTYPE_INLINE__

#define isxmbclower(c) ({int_ _i = (c); _i >= 0x8281 && _i <= 0x829a;})
#define isxmbcupper(c) ({int_ _i = (c); _i >= 0x8260 && _i <= 0x8279;})
#define xmbctolower(c) ({int_ _t = (c); isxmbcupper (_t) ? _t + 0x21 : _t;})
#define xmbctoupper(c) ({int_ _t = (c); isxmbclower (_t) ? _t - 0x21 : _t;})

#endif /* __NO_CTYPE_INLINE__ */

#endif
