#ifndef __mor_xmbstring_h__
#define __mor_xmbstring_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#ifndef __errno_h__
#include <errno.h>
#endif

#ifndef __size_t_defined__
#include <mor/size_t.h>
#endif

#ifndef NULL
#include <mor/null.h>
#endif

_EXTERN (int_ _xmblen (const unsigned char *));
_EXTERN (int_ xmbsnextc (const unsigned char *));
_EXTERN (size_t xmbsblen (const unsigned char *));
_EXTERN (size_t xmbscspn (const unsigned char *, const unsigned char *));
_EXTERN (size_t xmbsnbcnt (const unsigned char *, size_t));
_EXTERN (size_t xmbsspn (const unsigned char *, const unsigned char *));
_EXTERN (unsigned char *_xmbset (unsigned char *, int_));
_EXTERN (unsigned char *xmbscap (unsigned char *, const unsigned char *));
_EXTERN (unsigned char *xmbschr (const unsigned char *, int_));
_EXTERN (unsigned char *xmbscpy (unsigned char *, const unsigned char *));
_EXTERN (unsigned char *xmbsdup (const unsigned char *));
_EXTERN (unsigned char *xmbsinc (const unsigned char *));
_EXTERN (unsigned char *xmbsnecpy (unsigned char *, const unsigned char *, size_t));
_EXTERN (unsigned char *xmbstok (unsigned char *, const unsigned char *));
_EXTERN (unsigned char *xmbstok_r (unsigned char *, const unsigned char *, unsigned char **));
_EXTERN (unsigned char *xmbsuncap (unsigned char *, const unsigned char *));

#endif
