/* System headers */
#include <mor/xmbstring.h>
#include <mor/xmbctype.h>

/* Functions */
unsigned char *xmbsnecpy (unsigned char *dst, const unsigned char *src, size_t n)
{
unsigned char *ret = dst;
int ch;

    /* n Rs[ */
    while (n-- > 0 && (ch = xmbsnextc (src))) {
	dst = _xmbset (dst, ch);
	src += _ISXMB16 (ch) ? 2 : 1;
    }

    /* I[ł */
    *dst = 0;

    /* íjdst Ԃ */
    return ret;
}

/* EOF */
