/*
 * based on src/mbstring/_mbstok_r.c
 * iLIBC 1.1.32A ς cnm ̂Q{pb`j
 */

/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _mbstok_r.c
 */

/* System headers */
#include <mor/xmbstring.h>
#include <stddef.h>
#include <mor/xmbctype.h>

/* Functions */
unsigned char *xmbstok_r (unsigned char *str, const unsigned char *delim, unsigned char **last)
{
    int ch;
    unsigned char *token;

    /* last == NULL ܂ str == NULL  *last == NULL ̓G[ */
    if (last == NULL || (str == NULL && (str = *last) == NULL))
	return NULL;

    /* ̃f~^XLbv */
    while ((ch = xmbsnextc (str)) != '\0') {

	/* f~^? */
	if (xmbschr (delim, ch) == NULL)
	    break;

	/* |C^i߂ */
	str = xmbsinc (str);

    }

    /* ̏I */
    if (ch == '\0') {
	*last = NULL;
	return NULL;
    }

    /* g[NJnʒuL */
    token = str;

    /* f~^̌ */
    while ((ch = xmbsnextc (str)) != '\0') {

	/* f~^? */
	if (xmbschr (delim, ch) != NULL)
	    break;

	/* |C^i߂ */
	str = xmbsinc (str);

    }

    /* ̏I肩? */
    if (ch == '\0') {
	*last = NULL;
	return token;
    }

    /* f~^ null Ŗ߂ */
    *str++ = '\0';
    if (_ISXMB16(ch))
	*str++ = '\0';

    /* Ō̈ʒuLĖ߂ */
    *last = str;

    return token;
}

/* EOF */