/* System Headers */
#include <mor/xmbstring.h>
#include <ctype.h>
#include <mor/string.h>
#include <mor/xmbctype.h>

/* File Scope Functions */
/* g[NɏPł΃Ls^CY */
static void uncap (unsigned char *string, const unsigned char *delim)
{
unsigned char *top = string, flag = 0;
int ch;

    /* g[Nɏ邩ׂ */
    while ((ch = xmbsnextc (string)) && xmbschr (delim, ch) == NULL) {
	if (!_ISXMB16 (ch) && (flag = islower (ch)))
	    break;
	string = xmbsinc (string);
    }

    /* g[Nɏ΃Ls^CY */
    if (flag)
	_xmbset (top, tolower (*top));
}

/* Functions */
unsigned char *xmbsuncap (unsigned char *string, const unsigned char *delim)
{
unsigned char *ret = string;

    /* delim  NULL ȂftHg̃f~^g */
    if (delim == NULL)
	delim = _libmor_delim_default;

    /* ŏ̂Pɒu */
    uncap (string, delim);

    /* Ls^CY */
    while (xmbsnextc (string)) {
	/* f~^T */
	string += xmbscspn (string, delim);

	/* ̒P̐擪ֈړ */
	string += xmbsspn (string, delim);

	/* ɒu */
	if (xmbsnextc (string)) {
	    uncap (string, delim);
	    string = xmbsinc (string);
	}
    }

    return ret;
}

/* EOF */