#ifndef __mor_string_h__
#define __mor_string_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#ifndef __errno_h__
#include <errno.h>
#endif

#ifndef __size_t_defined__
#include <mor/size_t.h>
#endif

#ifndef NULL
#include <mor/null.h>
#endif

extern const char _libmor_delim_default[];

_EXTERN (char *addlastlf (char *));
_EXTERN (char *dellastlf (char *));
_EXTERN (char *stpncpy (char *, const char *, size_t));
_EXTERN (char *strcap (char *, const char *));
_EXTERN (char *strichr (const char *, int_));
_EXTERN (char *strirchr (const char *, int_));
_EXTERN (char *strmid (const char *, size_t, size_t));
_EXTERN (char *strndup (const char *, size_t));
_EXTERN (char *strnecpy (char *, const char *, size_t));
_EXTERN (char *strnins (char *, const char *, size_t));
_EXTERN (char *strnlwr (char *, size_t));
_EXTERN (char *strnrev (char *, size_t));
_EXTERN (char *strnupr (char *, size_t));
_EXTERN (char *strright (const char *, size_t));
_EXTERN (char *struncap (char *, const char *));
_EXTERN (size_t strnlen (const char *, size_t));
_EXTERN (void *memdup (const void *, size_t));
_EXTERN (void *memrev (void *, size_t, size_t));

#define strleft strndup
#define strncnt strnlen

#endif
